Index: svn/src/northbridge/amd/amdk8/Makefile.inc
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/Makefile.inc
+++ svn/src/northbridge/amd/amdk8/Makefile.inc
@@ -1,8 +1,3 @@
-
-#default CONFIG_AGP_APERTURE_SIZE=0x4000000
-#default CONFIG_HAVE_HIGH_TABLES=1
-
-
 driver-y += northbridge.o
 driver-y += misc_control.o
 obj-y += get_sblk_pci1234.o
Index: svn/src/mainboard/intel/eagleheights/Kconfig
===================================================================
--- svn.orig/src/mainboard/intel/eagleheights/Kconfig
+++ svn/src/mainboard/intel/eagleheights/Kconfig
@@ -7,7 +7,6 @@ config BOARD_INTEL_EAGLEHEIGHTS
 	select SUPERIO_INTEL_I3100
 	select SUPERIO_SMSC_SMSCSUPERIO
 	select HAVE_PIRQ_TABLE
-	select HAVE_HIGH_TABLES
 	select MMCONF_SUPPORT
 	select USE_PRINTK_IN_CAR
 	select UDELAY_TSC
@@ -21,6 +20,11 @@ config MAINBOARD_DIR
 	default intel/eagleheights
 	depends on BOARD_INTEL_EAGLEHEIGHTS
 
+config MMCONF_BASE_ADDRESS
+	hex
+	default 0xe0000000
+	depends on BOARD_INTEL_EAGLEHEIGHTS
+
 config DCACHE_RAM_BASE
 	hex
 	default 0xffdf8000
Index: svn/src/northbridge/intel/i945/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i945/Kconfig
+++ svn/src/northbridge/intel/i945/Kconfig
@@ -19,10 +19,5 @@
 
 config NORTHBRIDGE_INTEL_I945
 	bool
+	select HAVE_HIGH_TABLES
 	default n
-
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I945
-
Index: svn/src/northbridge/amd/amdk8/Kconfig
===================================================================
--- svn.orig/src/northbridge/amd/amdk8/Kconfig
+++ svn/src/northbridge/amd/amdk8/Kconfig
@@ -19,6 +19,7 @@
 
 config NORTHBRIDGE_AMD_AMDK8
 	bool
+	select HAVE_HIGH_TABLES
 	default n
 
 config AGP_APERTURE_SIZE
@@ -26,11 +27,6 @@ config AGP_APERTURE_SIZE
 	default 0x4000000
 	depends on NORTHBRIDGE_AMD_AMDK8
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_AMD_AMDK8
-
 config K8_HT_FREQ_1G
 	bool
 	default n
Index: svn/src/northbridge/amd/amdfam10/Kconfig
===================================================================
--- svn.orig/src/northbridge/amd/amdfam10/Kconfig
+++ svn/src/northbridge/amd/amdfam10/Kconfig
@@ -20,15 +20,11 @@
 config NORTHBRIDGE_AMD_AMDFAM10
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
 config AGP_APERTURE_SIZE
 	hex
 	default 0x4000000
 	depends on NORTHBRIDGE_AMD_AMDFAM10
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_AMD_AMDFAM10
-
 source src/northbridge/amd/amdfam10/root_complex/Kconfig
Index: svn/src/northbridge/intel/e7501/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/e7501/Kconfig
+++ svn/src/northbridge/intel/e7501/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_E7501
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_E7501
Index: svn/src/northbridge/intel/e7520/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/e7520/Kconfig
+++ svn/src/northbridge/intel/e7520/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_E7520
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_E7520
Index: svn/src/northbridge/intel/e7525/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/e7525/Kconfig
+++ svn/src/northbridge/intel/e7525/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_E7525
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_E7525
Index: svn/src/northbridge/intel/i3100/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i3100/Kconfig
+++ svn/src/northbridge/intel/i3100/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_I3100
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I3100
Index: svn/src/northbridge/intel/i440bx/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i440bx/Kconfig
+++ svn/src/northbridge/intel/i440bx/Kconfig
@@ -21,9 +21,5 @@
 config NORTHBRIDGE_INTEL_I440BX
 	bool
 	default n
-
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I440BX
+	select HAVE_HIGH_TABLES
 
Index: svn/src/northbridge/intel/i82810/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i82810/Kconfig
+++ svn/src/northbridge/intel/i82810/Kconfig
@@ -21,9 +21,5 @@
 config NORTHBRIDGE_INTEL_I82810
 	bool
 	default n
-
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I82810
+	select HAVE_HIGH_TABLES
 
Index: svn/src/northbridge/intel/i82830/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i82830/Kconfig
+++ svn/src/northbridge/intel/i82830/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_I82830
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I82830
Index: svn/src/northbridge/intel/i855gme/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i855gme/Kconfig
+++ svn/src/northbridge/intel/i855gme/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_I855GME
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I855GME
Index: svn/src/northbridge/intel/i855pm/Kconfig
===================================================================
--- svn.orig/src/northbridge/intel/i855pm/Kconfig
+++ svn/src/northbridge/intel/i855pm/Kconfig
@@ -1,8 +1,5 @@
 config NORTHBRIDGE_INTEL_I855PM
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_INTEL_I855PM
Index: svn/src/northbridge/via/cn700/Kconfig
===================================================================
--- svn.orig/src/northbridge/via/cn700/Kconfig
+++ svn/src/northbridge/via/cn700/Kconfig
@@ -1,13 +1,9 @@
 config NORTHBRIDGE_VIA_CN700
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
 config FALLBACK_SIZE
 	int
 	default 0
 	depends on NORTHBRIDGE_VIA_CN700
-
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_VIA_CN700
Index: svn/src/northbridge/via/vt8601/Kconfig
===================================================================
--- svn.orig/src/northbridge/via/vt8601/Kconfig
+++ svn/src/northbridge/via/vt8601/Kconfig
@@ -1,13 +1,10 @@
 config NORTHBRIDGE_VIA_VT8601
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
 config FALLBACK_SIZE
 	int
 	default 0
 	depends on NORTHBRIDGE_VIA_VT8601
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_VIA_VT8601
Index: svn/src/northbridge/via/vt8623/Kconfig
===================================================================
--- svn.orig/src/northbridge/via/vt8623/Kconfig
+++ svn/src/northbridge/via/vt8623/Kconfig
@@ -1,13 +1,10 @@
 config NORTHBRIDGE_VIA_VT8623
 	bool
 	default n
+	select HAVE_HIGH_TABLES
 
 config FALLBACK_SIZE
 	int
 	default 0
 	depends on NORTHBRIDGE_VIA_VT8623
 
-config HAVE_HIGH_TABLES
-	bool
-	default y
-	depends on NORTHBRIDGE_VIA_VT8623