[PATCH] Add sysinfo_have_multiboot function

Add a new infrastructure for returning system information to payloads.
First up - a pointer to the multiboot table.

Signed-off-by: Jordan Crouse <jordan@cosmicpenguin.net>

Index: libpayload/include/libpayload.h
===================================================================
--- libpayload.orig/include/libpayload.h	2008-11-07 14:38:16.000000000 -0700
+++ libpayload/include/libpayload.h	2008-11-07 14:38:22.000000000 -0700
@@ -421,6 +421,15 @@
 /** @} */
 
 /**
+ * @defgroup info System information functions
+ * This module contains functions that return information about the system
+ * @{
+ */
+
+int sysinfo_have_multiboot(unsigned long *addr);
+/** @} */
+
+/**
  * @defgroup arch Architecture specific functions
  * This module contains global architecture specific functions.
  * All architectures are expected to define these functions.
Index: libpayload/include/sysinfo.h
===================================================================
--- libpayload.orig/include/sysinfo.h	2008-11-07 14:38:16.000000000 -0700
+++ libpayload/include/sysinfo.h	2008-11-07 14:38:22.000000000 -0700
@@ -48,6 +48,8 @@
 	u32 cmos_range_start;
 	u32 cmos_range_end;
 	u32 cmos_checksum_location;
+
+	unsigned long *mbtable; /** Pointer to the multiboot table */
 };
 
 extern struct sysinfo_t lib_sysinfo;
Index: libpayload/i386/multiboot.c
===================================================================
--- libpayload.orig/i386/multiboot.c	2008-11-07 14:38:51.000000000 -0700
+++ libpayload/i386/multiboot.c	2008-11-07 14:38:55.000000000 -0700
@@ -86,6 +86,8 @@
 
 	table = (struct multiboot_header *) phys_to_virt(loader_ebx);
 
+	info->mbtable = phys_to_virt(loader_ebx);
+
 	if (table->flags & MULTIBOOT_FLAGS_MMAP)
 		mb_parse_mmap(table, info);
 
Index: libpayload/libc/sysinfo.c
===================================================================
--- /dev/null	1970-01-01 00:00:00.000000000 +0000
+++ libpayload/libc/sysinfo.c	2008-11-07 15:51:35.000000000 -0700
@@ -0,0 +1,39 @@
+/*
+ * This file is part of the libpayload project.
+ *
+ * Copyright (C) 2008 Advanced Micro Devices, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <libpayload.h>
+#include <sysinfo.h>
+
+extern struct sysinfo_t lib_sysinfo;
+
+int sysinfo_have_multiboot(unsigned long *addr)
+{
+	*addr = (unsigned long) lib_sysinfo.mbtable;
+	return (lib_sysinfo.mbtable == 0) ? 0 : 1;
+}
Index: libpayload/libc/Makefile.inc
===================================================================
--- libpayload.orig/libc/Makefile.inc	2008-11-07 15:51:09.000000000 -0700
+++ libpayload/libc/Makefile.inc	2008-11-07 15:51:15.000000000 -0700
@@ -31,4 +31,4 @@
 TARGETS-$(CONFIG_LIBC) += libc/malloc.o libc/printf.o libc/console.o libc/string.o
 TARGETS-$(CONFIG_LIBC) += libc/memory.o libc/ctype.o libc/ipchecksum.o libc/lib.o
 TARGETS-$(CONFIG_LIBC) += libc/rand.o libc/time.o libc/lar.o libc/exec.o
-TARGETS-$(CONFIG_LIBC) += libc/readline.o
+TARGETS-$(CONFIG_LIBC) += libc/readline.o libc/sysinfo.o