This is the final set of changes to allow rumba to build. Rumba is not
tested. 

Remaining problem: in src/arch/i386/Kconfig, I define AP_IN_SIPI_WAIT. But
in .config, I get:
#CONFIG_AP_IN_SIPI_WAIT is not set
Clearly I have more to learn about Kconfig. I want it so that if the 
mainboard Kconfig does not select it, it comes up as 'n'. 

Signed-off-by: Ronald G. Minnich <rminnich@gmail.com>

Index: src/southbridge/amd/Kconfig
===================================================================
--- src/southbridge/amd/Kconfig	(revision 4607)
+++ src/southbridge/amd/Kconfig	(working copy)
@@ -1,10 +1,10 @@
 source src/southbridge/amd/amd8111/Kconfig
 source src/southbridge/amd/amd8131/Kconfig
+source src/southbridge/amd/cs5536/Kconfig
 #source src/southbridge/amd/amd8131-disable/Kconfig
 #source src/southbridge/amd/amd8132/Kconfig
 #source src/southbridge/amd/amd8151/Kconfig
 #source src/southbridge/amd/cs5530/Kconfig
 #source src/southbridge/amd/cs5535/Kconfig
-#source src/southbridge/amd/cs5536/Kconfig
 source src/southbridge/amd/rs690/Kconfig
 source src/southbridge/amd/sb600/Kconfig
Index: src/cpu/amd/Kconfig
===================================================================
--- src/cpu/amd/Kconfig	(revision 4607)
+++ src/cpu/amd/Kconfig	(working copy)
@@ -8,3 +8,4 @@
 source src/cpu/amd/socket_S1G1/Kconfig
 
 source src/cpu/amd/model_fxx/Kconfig
+source src/cpu/amd/model_gx2/Kconfig
Index: src/cpu/amd/Makefile.inc
===================================================================
--- src/cpu/amd/Makefile.inc	(revision 4607)
+++ src/cpu/amd/Makefile.inc	(working copy)
@@ -1,4 +1,5 @@
 subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += socket_F
 subdirs-$(CONFIG_CPU_AMD_SOCKET_940) += socket_940
 subdirs-$(CONFIG_CPU_AMD_SOCKET_AM2) += socket_AM2
+subdirs-$(CONFIG_CPU_AMD_GX2) += model_gx2
 subdirs-$(CONFIG_CPU_AMD_SOCKET_S1G1) += socket_S1G1
Index: src/cpu/x86/tsc/Makefile.inc
===================================================================
--- src/cpu/x86/tsc/Makefile.inc	(revision 4607)
+++ src/cpu/x86/tsc/Makefile.inc	(working copy)
@@ -1,7 +1,2 @@
 obj-y += delay_tsc.o
 
-# default CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=0
-# if CONFIG_UDELAY_TSC
-# 	default CONFIG_HAVE_INIT_TIMER=1
-# 	object delay_tsc.o
-# end
Index: src/mainboard/amd/Kconfig
===================================================================
--- src/mainboard/amd/Kconfig	(revision 4607)
+++ src/mainboard/amd/Kconfig	(working copy)
@@ -1 +1,9 @@
-source "src/mainboard/amd/serengeti_cheetah/Kconfig"
\ No newline at end of file
+choice
+	prompt "Mainboard model"
+	depends on VENDOR_AMD
+
+source "src/mainboard/amd/serengeti_cheetah/Kconfig"
+source "src/mainboard/amd/rumba/Kconfig"
+
+endchoice
+
Index: src/mainboard/amd/rumba/Kconfig
===================================================================
--- src/mainboard/amd/rumba/Kconfig	(revision 0)
+++ src/mainboard/amd/rumba/Kconfig	(revision 0)
@@ -0,0 +1,62 @@
+
+
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2009 Uwe Hermann <uwe@hermann-uwe.de>
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+config BOARD_AMD_RUMBA
+	bool "Rumba"
+	select ARCH_X86
+	select CPU_AMD_GX2
+	select NORTHBRIDGE_AMD_GX2
+	select SOUTHBRIDGE_AMD_CS5536
+	select UDELAY_TSC
+	select HAVE_PIRQ_TABLE
+	help
+	  AMD Rumba mainboard.
+
+config MAINBOARD_DIR
+	string
+	default amd/rumba
+	depends on BOARD_AMD_RUMBA
+
+config MAINBOARD_PART_NUMBER
+	string
+	default "Rumba"
+	depends on BOARD_AMD_RUMBA
+
+config HAVE_OPTION_TABLE
+	bool
+	default n
+	depends on BOARD_AMD_RUMBA
+
+config IRQ_SLOT_COUNT
+	int
+	default 2
+	depends on BOARD_AMD_RUMBA
+
+config USE_INIT
+	int
+	default 0
+	depends on BOARD_AMD_RUMBA
+
+
+config TSC_X86RDTSC_CALIBRATE_WITH_TIMER2
+	int
+	default 0
+	depends on BOARD_AMD_RUMBA
Index: src/mainboard/amd/rumba/Makefile.inc
===================================================================
--- src/mainboard/amd/rumba/Makefile.inc	(revision 0)
+++ src/mainboard/amd/rumba/Makefile.inc	(revision 0)
@@ -0,0 +1 @@
+include $(src)/mainboard/Makefile.romccboard.inc
Index: src/mainboard/amd/serengeti_cheetah/Kconfig
===================================================================
--- src/mainboard/amd/serengeti_cheetah/Kconfig	(revision 4607)
+++ src/mainboard/amd/serengeti_cheetah/Kconfig	(working copy)
@@ -1,7 +1,3 @@
-choice
-	prompt "Mainboard model"
-	depends on VENDOR_AMD
-
 config BOARD_AMD_SERENGETI_CHEETAH
 	bool "Serengeti Cheetah"
 	select ARCH_X86
@@ -17,7 +13,6 @@
 	select USE_DCACHE_RAM
 	help
 	 AMD Serengeti Cheetah mainboard.
-endchoice
 
 config MAINBOARD_DIR
 	string
@@ -74,10 +69,6 @@
 	default "Serengeti-Cheetah"
 	depends on BOARD_AMD_SERENGETI_CHEETAH
 
-config PCI_64BIT_PREF_MEM
-	int
-	default 0
-	depends on BOARD_AMD_SERENGETI_CHEETAH
 
 config USE_FAILOVER_IMAGE
 	int
Index: src/northbridge/amd/Kconfig
===================================================================
--- src/northbridge/amd/Kconfig	(revision 4607)
+++ src/northbridge/amd/Kconfig	(working copy)
@@ -1,7 +1,8 @@
+source src/northbridge/amd/amdk8/Kconfig
+source src/northbridge/amd/gx2/Kconfig
+
 #source src/northbridge/amd/amdfam10/Kconfig
 #source src/northbridge/amd/amdht/Kconfig
-source src/northbridge/amd/amdk8/Kconfig
 #source src/northbridge/amd/amdmct/Kconfig
 #source src/northbridge/amd/gx1/Kconfig
-#source src/northbridge/amd/gx2/Kconfig
 #source src/northbridge/amd/lx/Kconfig
Index: src/arch/i386/Kconfig
===================================================================
--- src/arch/i386/Kconfig	(revision 4607)
+++ src/arch/i386/Kconfig	(working copy)
@@ -4,6 +4,14 @@
 	  This option is used to set the architecture of a mainboard.
 	  It is usually set in mainboard/*/Kconfig.
 
+config AP_IN_SIPI_WAIT
+	bool
+	default n
+	depends on ARCH_X86
+	help
+	  This is an SMP option. It relates to starting up APs. 
+	  It is usually set in mainboard/*/Kconfig.
+
 config ARCH
 	string
 	default i386